% example 7.2 from paper

fprintf('example 7.2 from paper\n')
close all
load B_N_calls
ncall = 400;
nhour = 240;
%nhour = 120;

B = B_N(1:nhour*ncall,1:nhour*ncall);

figure(100)
spy(B)
set(gca,'fontsize',12)
title('Data matrix')
drawnow

tic
y = recbcen(B,ncall,nhour,10);
time_elapsed = toc

%tic
%eBN2 = expm(B);
%y1 = sum(eBN2,2);
%time_elapsed1 = toc

S = reshape(y,[ncall nhour])';

figure(1)
plot(S)
xlim([1 nhour])
if nhour>96, set(gca,'xtick',[24:24:240]), end
xlabel('Time (hours)')
ylabel('Broadcasting centrality')
set(gca,'fontsize',12)
p1 = get(gcf,'position');
p1(4) = round(p1(4)*2/3);
set(gcf,'position',p1)

figure(2)
x = linspace(1,nhour,nhour)';
plot(x,S(:,1),x,S(:,2),x,S(:,3),x,S(:,5),x,S(:,200))
xlim([1 nhour])
if nhour>96, set(gca,'xtick',[24:24:240]), end
xlabel('Time (hours)')
ylabel('Broadcasting centrality')
legend('1','2','3','5','200')
set(gca,'fontsize',12)
p2 = get(gcf,'position');
p2(4) = round(p2(4)*2/3);
set(gcf,'position',p2)

figure(3)
plot(x,S(:,300),x,S(:,306),x,S(:,309),x,S(:,360),x,S(:,397))
xlim([1 nhour])
if nhour>96, set(gca,'xtick',[24:24:240]), end
xlabel('Time (hours)')
ylabel('Broadcasting centrality')
legend('300','306','309','360','397','location','northwest')
set(gca,'fontsize',12)
p2 = get(gcf,'position');
p2(4) = round(p2(4)*2/3);
set(gcf,'position',p2)

