% figure 4 and table 2 from paper
close all

%new block model
A11 = zeros(5);
A11([2,4,6,15,16,23]) = 1;
A22 = zeros(5);
A22([9,15,17,23]) = 1;
A33 = zeros(5);
A33([5,8,12,21]) = 1;
A44 = zeros(5);
A44([8,12,20,24]) = 1;
A12 = zeros(5);
A12([2,6,14,18]) = 1;
%A12 = A12 + eye(5); %waiting edges
A23 = zeros(5);
A23([5,9,17,21]) = 1;
%A23 = A23 + eye(5); %waiting edges
A34 = zeros(5);
A34([3,11,20,24]) = 1;
%A34 = A34 + eye(5); %waiting edges
B4 = [A11 A12 zeros(5,10);zeros(5) A22 A23 zeros(5); zeros(5,10) A33 A34;zeros(5,15) A44];

figure(1)
spy(B4)
set(gca,'fontsize',14)

%computing broacast centrality from time t_0 to time t_4
new_centr_vec = expm(B4)*ones(20,1);
new_centr = new_centr_vec(1:5);

[new_sort, i_new_sort] = sort(new_centr,'descend');

%FH block model
rho = zeros(4,1);

A1 = zeros(5);
A1([2,4,6,14,15,16,18,23]) = 1;
rho(1) = max(abs(eig(A1)));

A2 = zeros(5);
A2([2,5,6,9,14,15,17,18,21,23]) = 1;
rho(2) = max(abs(eig(A2)));

A3 = zeros(5);
A3([3,5,8,9,11,12,17,20,21,24]) = 1;
rho(3) = max(abs(eig(A3)));

A4 = zeros(5);
A4([3,8,11,12,15,24]) = 1;
rho(4) = max(abs(eig(A4)));

alfa = 0.9/max(rho);
beta = exp(-1);

BB4 = [alfa*A1, beta*eye(5), zeros(5,10);
	zeros(5), alfa*A2, beta*eye(5), zeros(5);
	zeros(5,10), alfa*A3, beta*eye(5);
	zeros(5,15), alfa*A4];

figure(2)
spy(BB4)
set(gca,'fontsize',14)

%another way to compute old_centr by using the block matrix BB4
%just to check if computation is correct

% Ibig = speye(20);
% evec = ones(5,1);
% vecbig = [sparse(15,1);sparse(evec)]; %this is kron(e_M,ones(M,1))
% res_big = (Ibig - BB4)\vecbig;
% d = 1 - v;
% sys_val = kron(d,In)'*res_big - evec;
In = speye(5);

old_Qcentr = ones(5,1);
for i = 4:-1:1
	eval(sprintf('X = A%d;',i));
	old_Qcentr = (In - alfa*X)\old_Qcentr;
end

[old_Qsort, i_old_Qsort] = sort(old_Qcentr,'descend');

fprintf('\n\n*** Resolvent-based centrality ***')
fprintf('\nranking \t value of centrality')
fprintf('\n%d \t\t %.2f',[i_old_Qsort,old_Qsort]')

fprintf('\n\n*** Exponential-based centrality ***')
fprintf('\nranking \t value of centrality')
fprintf('\n%d \t\t %.2f',[i_new_sort,new_sort]')

fprintf('\n\n\n')

