% figure 5 and table 3 from paper
close all

%new block model
A11 = zeros(5);
A11(1,2) = 1;
A11(3,5) = 1;
A11 = A11 + A11';
A22 = zeros(5);
A22(1,2) = 1;
A22(3,4) = 1;
A22 = A22 + A22';
A33 = zeros(5);
A33(2,4) = 1;
A33 = A33 + A33';
A44 = zeros(5);
A44(1,5) = 1;
A44(2,3) = 1;
A44 = A44 + A44';
A55 = zeros(5);
A55(1,3) = 1;
A55(4,5) = 1;
A55 = A55 + A55';
A66 = zeros(5);
A66(4,5) = 1;
A66 = A66 + A66';

A12 = zeros(5);
A12(1,4) = 1;
A12 = A12 + A12';
A23 = zeros(5);
A23(3,5) = 1;
A23 = A23 + A23';
A34 = zeros(5);
A34(1,5) = 1;
A34(2,4) = 1;
A34 = A34 + A34';
A45 = zeros(5);
A56 = zeros(5);
A56(2,3) = 1;
A56 = A56 + A56';

B6 = [A11 A12 zeros(5,20);
	zeros(5) A22 A23 zeros(5,15); 
	zeros(5,10) A33 A34 zeros(5,10);
	zeros(5,15) A44 A45 zeros(5);
	zeros(5,20) A55 A56;
	zeros(5,25) A66];


figure(1)
spy(B6)
set(gca,'fontsize',14)

%computing broacast centrality from time t_0 to time t_4
new_centr_vec = expm(B6)*ones(30,1);
new_centr = new_centr_vec(1:5);

[new_sort, i_new_sort] = sort(new_centr,'descend');

%FH block model
rho = zeros(6,1);

A1 = zeros(5);
A1([2,4,6,15,16,23]) = 1;
rho(1) = max(abs(eig(A1)));

A2 = zeros(5);
A2([2,4,6,14,15,16,18,23]) = 1;
rho(2) = max(abs(eig(A2)));

A3 = zeros(5);
A3([5,9,15,17,21,23]) = 1;
rho(3) = max(abs(eig(A3)));

A4 = zeros(5);
A4([5,8,9,12,17,21]) = 1;
rho(4) = max(abs(eig(A4)));

A5 = zeros(5);
A5([3,8,11,12,20,24]) = 1;
rho(5) = max(abs(eig(A5)));

A6 = zeros(5);
A6([8,12,20,24]) = 1;
rho(6) = max(abs(eig(A6)));

alfa = 0.9/max(rho);
beta = exp(-1/6);

BB6 = [alfa*A1, beta*eye(5), zeros(5,20);
	zeros(5), alfa*A2, beta*eye(5), zeros(5,15);
	zeros(5,10), alfa*A3, beta*eye(5) zeros(5,10);
	zeros(5,15), alfa*A4, beta*eye(5) zeros(5);
	zeros(5,20), alfa*A5, beta*eye(5)
	zeros(5,25), alfa*A6];

figure(2)
spy(BB6)
set(gca,'fontsize',14)

In = speye(5);

old_Qcentr = ones(5,1);
for i = 6:-1:1
	eval(sprintf('X = A%d;',i));
	old_Qcentr = (In - alfa*X)\old_Qcentr;
end

[old_Qsort, i_old_Qsort] = sort(old_Qcentr,'descend');

fprintf('\n\n*** Resolvent-based centrality ***')
fprintf('\nranking \t value of centrality')
fprintf('\n%d \t\t %.2f',[i_old_Qsort,old_Qsort]')

fprintf('\n\n*** Exponential-based centrality ***')
fprintf('\nranking \t value of centrality')
fprintf('\n%d \t\t %.2f',[i_new_sort,new_sort]')

fprintf('\n\n\n')

